# coding: utf-8

# flake8: noqa

"""
    Container Registry service

    Container Registry service enables IONOS clients to manage docker and OCI compliant registries for use by their managed Kubernetes clusters. Use a Container Registry to ensure you have a privately accessed registry to efficiently support image pulls.  # noqa: E501

    The version of the OpenAPI document: 1.0
    Contact: support@cloud.ionos.com
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import

__version__ = "1.0.0"

# import apis into sdk package
from ionoscloud_container_registry.api.locations_api import LocationsApi
from ionoscloud_container_registry.api.names_api import NamesApi
from ionoscloud_container_registry.api.registries_api import RegistriesApi
from ionoscloud_container_registry.api.repositories_api import RepositoriesApi
from ionoscloud_container_registry.api.tokens_api import TokensApi

# import ApiClient
from ionoscloud_container_registry.api_client import ApiClient
from ionoscloud_container_registry.configuration import Configuration
from ionoscloud_container_registry.exceptions import OpenApiException
from ionoscloud_container_registry.exceptions import ApiTypeError
from ionoscloud_container_registry.exceptions import ApiValueError
from ionoscloud_container_registry.exceptions import ApiKeyError
from ionoscloud_container_registry.exceptions import ApiAttributeError
from ionoscloud_container_registry.exceptions import ApiException
# import models into sdk package
from ionoscloud_container_registry.models.api_error_message import ApiErrorMessage
from ionoscloud_container_registry.models.api_error_response import ApiErrorResponse
from ionoscloud_container_registry.models.api_resource_metadata import ApiResourceMetadata
from ionoscloud_container_registry.models.credentials import Credentials
from ionoscloud_container_registry.models.day import Day
from ionoscloud_container_registry.models.location import Location
from ionoscloud_container_registry.models.locations_response import LocationsResponse
from ionoscloud_container_registry.models.pagination_links import PaginationLinks
from ionoscloud_container_registry.models.patch_registry_input import PatchRegistryInput
from ionoscloud_container_registry.models.patch_token_input import PatchTokenInput
from ionoscloud_container_registry.models.post_registry_input import PostRegistryInput
from ionoscloud_container_registry.models.post_registry_output import PostRegistryOutput
from ionoscloud_container_registry.models.post_registry_properties import PostRegistryProperties
from ionoscloud_container_registry.models.post_token_input import PostTokenInput
from ionoscloud_container_registry.models.post_token_output import PostTokenOutput
from ionoscloud_container_registry.models.post_token_properties import PostTokenProperties
from ionoscloud_container_registry.models.put_registry_input import PutRegistryInput
from ionoscloud_container_registry.models.put_registry_output import PutRegistryOutput
from ionoscloud_container_registry.models.put_token_input import PutTokenInput
from ionoscloud_container_registry.models.put_token_output import PutTokenOutput
from ionoscloud_container_registry.models.registries_response import RegistriesResponse
from ionoscloud_container_registry.models.registry_properties import RegistryProperties
from ionoscloud_container_registry.models.registry_response import RegistryResponse
from ionoscloud_container_registry.models.scope import Scope
from ionoscloud_container_registry.models.storage_usage import StorageUsage
from ionoscloud_container_registry.models.token_properties import TokenProperties
from ionoscloud_container_registry.models.token_response import TokenResponse
from ionoscloud_container_registry.models.tokens_response import TokensResponse
from ionoscloud_container_registry.models.weekly_schedule import WeeklySchedule

