# coding: utf-8

"""
    Container Registry service

    Container Registry service enables IONOS clients to manage docker and OCI compliant registries for use by their managed Kubernetes clusters. Use a Container Registry to ensure you have a privately accessed registry to efficiently support image pulls.  # noqa: E501

    The version of the OpenAPI document: 1.0
    Contact: support@cloud.ionos.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ionoscloud_container_registry.configuration import Configuration


class StorageUsage(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {

        'bytes': 'int',

        'updated_at': 'datetime',
    }

    attribute_map = {

        'bytes': 'bytes',

        'updated_at': 'updatedAt',
    }

    def __init__(self, bytes=None, updated_at=None, local_vars_configuration=None):  # noqa: E501
        """StorageUsage - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._bytes = None
        self._updated_at = None
        self.discriminator = None

        self.bytes = bytes
        self.updated_at = updated_at


    @property
    def bytes(self):
        """Gets the bytes of this StorageUsage.  # noqa: E501


        :return: The bytes of this StorageUsage.  # noqa: E501
        :rtype: int
        """
        return self._bytes

    @bytes.setter
    def bytes(self, bytes):
        """Sets the bytes of this StorageUsage.


        :param bytes: The bytes of this StorageUsage.  # noqa: E501
        :type bytes: int
        """

        self._bytes = bytes

    @property
    def updated_at(self):
        """Gets the updated_at of this StorageUsage.  # noqa: E501


        :return: The updated_at of this StorageUsage.  # noqa: E501
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this StorageUsage.


        :param updated_at: The updated_at of this StorageUsage.  # noqa: E501
        :type updated_at: datetime
        """

        self._updated_at = updated_at
    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, StorageUsage):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, StorageUsage):
            return True

        return self.to_dict() != other.to_dict()
