# coding: utf-8

"""
    Container Registry service

    Container Registry service enables IONOS clients to manage docker and OCI compliant registries for use by their managed Kubernetes clusters. Use a Container Registry to ensure you have a privately accessed registry to efficiently support image pulls.  # noqa: E501

    The version of the OpenAPI document: 1.0
    Contact: support@cloud.ionos.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ionoscloud_container_registry.configuration import Configuration


class WeeklySchedule(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {

        'days': 'list[Day]',

        'time': 'str',
    }

    attribute_map = {

        'days': 'days',

        'time': 'time',
    }

    def __init__(self, days=None, time=None, local_vars_configuration=None):  # noqa: E501
        """WeeklySchedule - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._days = None
        self._time = None
        self.discriminator = None

        self.days = days
        self.time = time


    @property
    def days(self):
        """Gets the days of this WeeklySchedule.  # noqa: E501


        :return: The days of this WeeklySchedule.  # noqa: E501
        :rtype: list[Day]
        """
        return self._days

    @days.setter
    def days(self, days):
        """Sets the days of this WeeklySchedule.


        :param days: The days of this WeeklySchedule.  # noqa: E501
        :type days: list[Day]
        """

        self._days = days

    @property
    def time(self):
        """Gets the time of this WeeklySchedule.  # noqa: E501

        UTC time of day e.g. 01:00:00 - as defined by partial-time - RFC3339  # noqa: E501

        :return: The time of this WeeklySchedule.  # noqa: E501
        :rtype: str
        """
        return self._time

    @time.setter
    def time(self, time):
        """Sets the time of this WeeklySchedule.

        UTC time of day e.g. 01:00:00 - as defined by partial-time - RFC3339  # noqa: E501

        :param time: The time of this WeeklySchedule.  # noqa: E501
        :type time: str
        """
        if self.local_vars_configuration.client_side_validation and time is None:  # noqa: E501
            raise ValueError("Invalid value for `time`, must not be `None`")  # noqa: E501

        self._time = time
    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, WeeklySchedule):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, WeeklySchedule):
            return True

        return self.to_dict() != other.to_dict()
